ALTER TABLE `ordemservico`.`ordens_servico` 
CHANGE COLUMN `material` `material` VARCHAR(100) NULL DEFAULT NULL ,
ADD COLUMN `id_material` INT(11) NOT NULL AFTER `material`,
ADD INDEX `fk_ordens_servico_materiais_idx` (`id_material` ASC);

ALTER TABLE `ordemservico`.`ordem_servico_modelo` 
CHANGE COLUMN `material` `material` VARCHAR(100) NULL DEFAULT NULL ,
ADD COLUMN `id_material` INT(11) NOT NULL AFTER `material`,
ADD INDEX `fk_ordem_servico_modelo_materiais_idx` (`id_material` ASC);

CREATE TABLE IF NOT EXISTS `ordemservico`.`materiais` (
  `id` INT(11) NOT NULL AUTO_INCREMENT,
  `descricao` VARCHAR(100) NOT NULL,
  `fabricante` VARCHAR(50) NOT NULL,
  PRIMARY KEY (`id`))
ENGINE = InnoDB
DEFAULT CHARACTER SET = utf8
COLLATE = utf8_general_ci;

ALTER TABLE `ordemservico`.`ordens_servico` 
ADD CONSTRAINT `fk_ordens_servico_materiais`
  FOREIGN KEY (`id_material`)
  REFERENCES `ordemservico`.`materiais` (`id`)
  ON DELETE NO ACTION
  ON UPDATE NO ACTION;

ALTER TABLE `ordemservico`.`ordem_servico_modelo` 
ADD CONSTRAINT `fk_ordem_servico_modelo_materiais`
  FOREIGN KEY (`id_material`)
  REFERENCES `ordemservico`.`materiais` (`id`)
  ON DELETE NO ACTION
  ON UPDATE NO ACTION;

ALTER TABLE `ordemservico`.`ordens_servico` 
DROP COLUMN `material`;

ALTER TABLE `ordemservico`.`ordem_servico_modelo` 
DROP COLUMN `material`;

ALTER TABLE `ordemservico`.`ordens_servico` 
DROP FOREIGN KEY `fk_ordens_servico_materiais`;

ALTER TABLE `ordemservico`.`ordem_servico_modelo` 
DROP FOREIGN KEY `fk_ordem_servico_modelo_materiais`;

ALTER TABLE `ordemservico`.`ordens_servico` 
CHANGE COLUMN `id_material` `material` INT(11) NOT NULL ;

ALTER TABLE `ordemservico`.`ordem_servico_modelo` 
CHANGE COLUMN `id_material` `material` INT(11) NOT NULL ;

ALTER TABLE `ordemservico`.`ordens_servico` 
ADD CONSTRAINT `fk_ordens_servico_materiais`
  FOREIGN KEY (`material`)
  REFERENCES `ordemservico`.`materiais` (`id`)
  ON DELETE NO ACTION
  ON UPDATE NO ACTION;

ALTER TABLE `ordemservico`.`ordem_servico_modelo` 
ADD CONSTRAINT `fk_ordem_servico_modelo_materiais`
  FOREIGN KEY (`material`)
  REFERENCES `ordemservico`.`materiais` (`id`)
  ON DELETE NO ACTION
  ON UPDATE NO ACTION;


ALTER TABLE `ordemservico`.`materiais` 
ADD COLUMN `ativo` TINYINT(1) NOT NULL AFTER `fabricante`;

INSERT INTO funcoes (nome, chave) VALUES ('Listar Materiais', 'LISTAR_MATERIAIS');
INSERT INTO funcoes (nome, chave) VALUES ('Cadastrar Materiais', 'CADASTRAR_MATERIAIS');
INSERT INTO funcoes (nome, chave) VALUES ('Editar Materiais', 'EDITAR_MATERIAIS');
INSERT INTO funcoes (nome, chave) VALUES ('Excluir Materiais', 'EXCLUIR_MATERIAIS');

ALTER TABLE `ordemservico`.`equipamentos` 
CHANGE COLUMN `data_aquisicao` `data_aquisicao` DATE NULL DEFAULT NULL;

ALTER TABLE `ordemservico`.`ordens_servico` 
ADD COLUMN `ordem` INT(11) NOT NULL DEFAULT 0 AFTER `cancelado`;


