-- MySQL Script generated by MySQL Workbench
-- Ter 06 Out 2015 16:36:52 BRT
-- Model: New Model    Version: 1.0
-- MySQL Workbench Forward Engineering

SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0;
SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0;
SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='TRADITIONAL,ALLOW_INVALID_DATES';

-- -----------------------------------------------------
-- Schema ordemservico
-- -----------------------------------------------------

-- -----------------------------------------------------
-- Schema ordemservico
-- -----------------------------------------------------
CREATE SCHEMA IF NOT EXISTS `ordemservico` DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci ;
USE `ordemservico` ;

-- -----------------------------------------------------
-- Table `ordemservico`.`grupos`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `ordemservico`.`grupos` (
  `id` INT NOT NULL AUTO_INCREMENT,
  `nome` VARCHAR(50) NOT NULL,
  `ativo` TINYINT(1) NOT NULL DEFAULT 1,
  PRIMARY KEY (`id`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `ordemservico`.`usuarios`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `ordemservico`.`usuarios` (
  `id` INT NOT NULL AUTO_INCREMENT,
  `nome` VARCHAR(150) NOT NULL,
  `endereco` VARCHAR(255) NOT NULL,
  `bairro` VARCHAR(80) NULL,
  `cidade` VARCHAR(80) NOT NULL,
  `uf` CHAR(2) NOT NULL,
  `cep` CHAR(8) NOT NULL,
  `telefone` VARCHAR(11) NULL,
  `celular` VARCHAR(11) NOT NULL,
  `cargo` VARCHAR(50) NOT NULL,
  `setor` VARCHAR(50) NOT NULL,
  `email` VARCHAR(50) NOT NULL,
  `nickname` VARCHAR(32) NOT NULL,
  `senha` VARCHAR(50) NOT NULL,
  `grupo` INT NOT NULL,
  `ativo` TINYINT(1) NOT NULL,
  `verificar` TINYINT(1) NOT NULL,
  PRIMARY KEY (`id`),
  INDEX `fk_usuarios_grupos_idx` (`grupo` ASC),
  UNIQUE INDEX `email_UNIQUE` (`email` ASC),
  CONSTRAINT `fk_usuarios_grupos`
    FOREIGN KEY (`grupo`)
    REFERENCES `ordemservico`.`grupos` (`id`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `ordemservico`.`clientes`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `ordemservico`.`clientes` (
  `id` INT NOT NULL AUTO_INCREMENT,
  `razao_social` VARCHAR(255) NOT NULL,
  `nome_fantasia` VARCHAR(255) NULL,
  `endereco` VARCHAR(255) NOT NULL,
  `bairro` VARCHAR(80) NULL,
  `cidade` VARCHAR(80) NOT NULL,
  `uf` CHAR(2) NOT NULL,
  `cep` CHAR(8) NOT NULL,
  `telefone` VARCHAR(11) NULL,
  `celular` VARCHAR(11) NULL,
  `documento_fiscal` VARCHAR(15) NOT NULL,
  `email` VARCHAR(50) NULL,
  `tipo_cliente` CHAR(1) NOT NULL,
  `ativo` TINYINT(1) NOT NULL,
  `data_cadastro` DATETIME NOT NULL,
  `data_alteracao` DATETIME NULL,
  PRIMARY KEY (`id`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `ordemservico`.`equipamentos`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `ordemservico`.`equipamentos` (
  `id` INT NOT NULL AUTO_INCREMENT,
  `nome` VARCHAR(80) NOT NULL,
  `fabricante` VARCHAR(80) NOT NULL,
  `modelo` VARCHAR(30) NOT NULL,
  `data_aquisicao` DATE NULL,
  `ativo` TINYINT(1) NOT NULL,
  PRIMARY KEY (`id`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `ordemservico`.`modo_entrega`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `ordemservico`.`modo_entrega` (
  `id` INT NOT NULL AUTO_INCREMENT,
  `nome` VARCHAR(50) NOT NULL,
  `ativo` TINYINT(1) NOT NULL,
  PRIMARY KEY (`id`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `ordemservico`.`materiais`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `ordemservico`.`materiais` (
  `id` INT NOT NULL AUTO_INCREMENT,
  `descricao` VARCHAR(100) NOT NULL,
  `fabricante` VARCHAR(50) NOT NULL,
  `ativo` TINYINT(1) NOT NULL,
  PRIMARY KEY (`id`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `ordemservico`.`ordens_servico`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `ordemservico`.`ordens_servico` (
  `id` INT NOT NULL AUTO_INCREMENT,
  `id_cliente` INT NOT NULL,
  `servico` VARCHAR(300) NOT NULL,
  `material` INT NOT NULL,
  `formato` VARCHAR(30) NOT NULL,
  `formato_final` VARCHAR(30) NOT NULL,
  `data_criacao` DATETIME NOT NULL,
  `quantidade_producao` INT NOT NULL,
  `quantidade_cliente` INT NOT NULL,
  `acabamento` VARCHAR(50) NOT NULL,
  `prazo` DATE NULL,
  `arquivo` VARCHAR(255) NULL,
  `equipamento` INT NOT NULL,
  `modo_entrega` INT NOT NULL,
  `contato_cliente` VARCHAR(50) NULL,
  `observacoes` TEXT NULL,
  `prioridade` INT NOT NULL,
  `concluido` TINYINT(1) NOT NULL,
  `responsavel` INT NOT NULL,
  `cancelado` TINYINT(1) NOT NULL DEFAULT 0,
  `ordem` INT NOT NULL DEFAULT 0,
  PRIMARY KEY (`id`),
  INDEX `fk_ordens_servico_usuarios_idx` (`responsavel` ASC),
  INDEX `fk_ordens_servico_clientes_idx` (`id_cliente` ASC),
  INDEX `fk_ordens_servico_equipamentos_idx` (`equipamento` ASC),
  INDEX `fk_ordens_servico_entrega_idx` (`modo_entrega` ASC),
  INDEX `fk_ordens_servico_materiais_idx` (`material` ASC),
  CONSTRAINT `fk_ordens_servico_usuarios`
    FOREIGN KEY (`responsavel`)
    REFERENCES `ordemservico`.`usuarios` (`id`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_ordens_servico_clientes`
    FOREIGN KEY (`id_cliente`)
    REFERENCES `ordemservico`.`clientes` (`id`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_ordens_servico_equipamentos`
    FOREIGN KEY (`equipamento`)
    REFERENCES `ordemservico`.`equipamentos` (`id`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_ordens_servico_entrega`
    FOREIGN KEY (`modo_entrega`)
    REFERENCES `ordemservico`.`modo_entrega` (`id`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_ordens_servico_materiais`
    FOREIGN KEY (`material`)
    REFERENCES `ordemservico`.`materiais` (`id`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `ordemservico`.`funcoes`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `ordemservico`.`funcoes` (
  `id` INT NOT NULL AUTO_INCREMENT,
  `nome` VARCHAR(50) NOT NULL,
  `chave` VARCHAR(45) NOT NULL,
  PRIMARY KEY (`id`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `ordemservico`.`ordem_servico_modelo`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `ordemservico`.`ordem_servico_modelo` (
  `id` INT NOT NULL AUTO_INCREMENT,
  `id_cliente` INT NOT NULL,
  `servico` VARCHAR(300) NOT NULL,
  `material` INT NOT NULL,
  `formato` VARCHAR(30) NOT NULL,
  `formato_final` VARCHAR(30) NOT NULL,
  `quantidade_producao` INT NOT NULL,
  `quantidade_cliente` INT NOT NULL,
  `acabamento` VARCHAR(50) NOT NULL,
  `data_criacao` DATETIME NOT NULL,
  `arquivo` VARCHAR(255) NULL,
  `equipamento` INT NOT NULL,
  `modo_entrega` INT NOT NULL,
  `contato_cliente` VARCHAR(50) NULL,
  `ordem_servico_origem` INT NULL,
  PRIMARY KEY (`id`),
  INDEX `fk_ordem_servico_modelo_cliente_idx` (`id_cliente` ASC),
  INDEX `fk_ordem_servico_modelo_equipamentos_idx` (`equipamento` ASC),
  INDEX `fk_ordem_servico_idx` (`ordem_servico_origem` ASC),
  INDEX `fk_ordem_servico_modelo_entrega_idx` (`modo_entrega` ASC),
  INDEX `fk_ordem_servico_modelo_materiais_idx` (`material` ASC),
  CONSTRAINT `fk_ordem_servico_modelo_cliente`
    FOREIGN KEY (`id_cliente`)
    REFERENCES `ordemservico`.`clientes` (`id`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_ordem_servico_modelo_equipamentos`
    FOREIGN KEY (`equipamento`)
    REFERENCES `ordemservico`.`equipamentos` (`id`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_ordem_servico`
    FOREIGN KEY (`ordem_servico_origem`)
    REFERENCES `ordemservico`.`ordens_servico` (`id`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_ordem_servico_modelo_entrega`
    FOREIGN KEY (`modo_entrega`)
    REFERENCES `ordemservico`.`modo_entrega` (`id`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_ordem_servico_modelo_materiais`
    FOREIGN KEY (`material`)
    REFERENCES `ordemservico`.`materiais` (`id`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `ordemservico`.`funcoes_grupos`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `ordemservico`.`funcoes_grupos` (
  `funcoes_id` INT NOT NULL,
  `grupos_id` INT NOT NULL,
  PRIMARY KEY (`funcoes_id`, `grupos_id`),
  INDEX `fk_funcoes_has_grupos_grupos1_idx` (`grupos_id` ASC),
  INDEX `fk_funcoes_has_grupos_funcoes1_idx` (`funcoes_id` ASC),
  CONSTRAINT `fk_funcoes_has_grupos_funcoes1`
    FOREIGN KEY (`funcoes_id`)
    REFERENCES `ordemservico`.`funcoes` (`id`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_funcoes_has_grupos_grupos1`
    FOREIGN KEY (`grupos_id`)
    REFERENCES `ordemservico`.`grupos` (`id`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `ordemservico`.`tokens`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `ordemservico`.`tokens` (
  `chave` CHAR(40) NOT NULL,
  `usuario` INT NOT NULL,
  `produto` VARCHAR(20) NULL,
  `datacriacao` DATETIME NOT NULL,
  `ativo` BIT NOT NULL,
  `resolvido` BIT NOT NULL,
  PRIMARY KEY (`chave`))
ENGINE = InnoDB;


SET SQL_MODE=@OLD_SQL_MODE;
SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS;
SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS;
